# weba

[![Release](https://img.shields.io/github/v/release/cj/weba)](https://img.shields.io/github/v/release/cj/weba)
[![Build status](https://img.shields.io/github/actions/workflow/status/cj/weba/main.yml?branch=main)](https://github.com/cj/weba/actions/workflows/main.yml?query=branch%3Amain)
[![codecov](https://codecov.io/gh/cj/weba/branch/main/graph/badge.svg)](https://codecov.io/gh/cj/weba)
[![Commit activity](https://img.shields.io/github/commit-activity/m/cj/weba)](https://img.shields.io/github/commit-activity/m/cj/weba)
[![License](https://img.shields.io/github/license/cj/weba)](https://img.shields.io/github/license/cj/weba)

Weba is a Python library for building web user interfaces using a declarative,
component-based approach. It provides a clean API for creating HTML elements and
components with proper context management and type safety. The library extends
BeautifulSoup's functionality by adding a custom Tag class that supports modern web
development patterns, including HTMX integration, class list manipulation, and
comment-based selectors. It allows developers to create reusable UI components with
proper isolation, supports both synchronous and asynchronous contexts, and handles
attribute management (including JSON serialization) elegantly. The library emphasizes
type safety and follows clean code practices, making it particularly suitable for
building modern web applications in Python with a focus on maintainability and developer
experience.

- **Github repository**: <https://github.com/cj/weba/>
- **Documentation** <https://weba.cj.io/>
